Define manually the versions order in Roadmap (when date isn't defined)
Status: New Start date: 2010-11-25

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Roadmap Estimated time: 0.00 hour

Target version:    

Resolution:    

Description

Hi,

in my project, I've many versions in my Roadmap.

Actually version are ordered by date and by title.

In my project, I don't define release date, however I would like to define the versions order.

Is it possible to append this feature ?

Regards,

Stephane

Related issues:

Related to Redmine - Feature #6881: Version numbering sort New 2010-11-13

Related to Redmine - Feature #1137: Project version Closed 2008-04-29

Has duplicate Redmine - Feature #12814: Ability to specify target version sor... Reopened

Has duplicate Redmine - Feature #8080: Option for alphabetical only sorting o... Closed 2011-04-06

Has duplicate Redmine - Feature #13681: Option to choose sorting versions in ... Closed

History

#1 - 2013-03-25 21:38 - Dipan Mehta

+100. This is a very critical functionality.

Version name (automated) sorting has been an issue with debates and still there seems no universally accepted way. See related issues: #11153 vs. 

#12814. What is otherwise not reported but becomes even more mess when there are multiple projects sharing their versions across tree/hierarchy

and none has a date for it!

Other related issues are: #6881, #7269, #8080

The trouble is, there won't ever be a one-fit-solution-for-all. I think best situation can be if the versions are allowed to be explicitly manually ordered on

the versions page.

It doesn't take a genius to make it -but might ease everyone's problems.

+100 please implement this.

#2 - 2013-12-02 13:26 - Daniel Albuschat

+1 from me, too.

We use Versions as "Milestones" with descriptive texts, hence an alphabetical order is not useful to us.

We use redmine to plan our projects, too, and there are no due dates while planning.

This means that versions are in a totally useless order while planning a project, which is a real burden to the planner and makes it difficult to talk

about a project in the planning phase based on the roadmap.

#3 - 2013-12-17 10:55 - ixbidie ixbidie

+1 too

joining my previous speakers

#4 - 2015-02-02 07:31 - chu chu
https://www.redmine.org/issues/11153
https://www.redmine.org/issues/12814
https://www.redmine.org/issues/6881
https://www.redmine.org/issues/7269
https://www.redmine.org/issues/8080


+1

I think most people want least version in top of the list, like

https://github.com/redmine/redmine/releases

or

http://jmeter-plugins.org/downloads/all/

If I made the PR, will you accept it?

#5 - 2015-02-11 21:58 - Bryn Jeffries

+1

Ideally this should be configurable, but by default the order should by according to the displayed text. I can get what I want by hacking

app/models/version.rb to

  # Versions are sorted by name

  # then by effective date (nulls lose) and then id

  def <=>(version)

    if name == version.name

      if self.effective_date

        if version.effective_date

          self.effective_date == version.effective_date ? id <=> version.id : self.effective_date <=> version.

effective_date

        else

          1

        end

      else

         -1

      end

    else

      name <=> version.name

    end

  end

#6 - 2016-11-01 18:54 - nano devel

+1

#7 - 2017-11-09 10:08 - Klavs Klavsen

Will this ever get accepted into redmine? I'm really missing it :(

#8 - 2020-12-17 11:32 - Sunding Wei

10 years later, I still need this feature desperately.

#9 - 2020-12-17 15:29 - Sunding Wei

- File version-order.png added

I finally solved the roadmap versions sorting issue, see the screenshot, assume we always create bigger version each time.

 version-order.png 

The changed code of: app/models/version.rb

  def <=>(version)

    if self.effective_date

      if version.effective_date

        # both have dates

        if self.effective_date == version.effective_date

          # 1. (v0.1) to (v0.2)

          id <=> version.id

        else

          # 2. (early) to (later)

          self.effective_date <=> version.effective_date

        end

      else

        # 3. (date) to (no date)

        -1

      end

    else

      if version.effective_date

        # 4. (date) to (no date)
        1

      else

        # 5. both no dates, order by id descent

        version.id <=> id

      end

    end

  end

#10 - 2023-01-10 22:00 - Holger Just

- Related to Feature #1137: Project version added

Files

version-order.png 310 KB 2020-12-17 Sunding Wei
